registerGameMode("Siege","SG",1,1,1);
setGameModeHelp("Siege","Add-Ons/Gamemode_Siege/rules_siege.txt");
addGameModeRule("Siege","Time","int 1 30",10);

//Game Mode Rules
//- Time to Defend (min) [int 1 20 10]

function GameMode_SG_GetSpecialTeams(%client)
{
 commandtoclient(%client,'tdmSpecialClearTeams');

 commandtoclient(%client,'tdmSpecialSendTeam',0,"Attackers" TAB
							getClosestPaintColor("1 0 0 1") TAB
							1 TAB
							PlayerStandardArmor.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							PlayerStandardArmor.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							0);

 commandtoclient(%client,'tdmSpecialSendTeam',1,"Defenders" TAB
							getClosestPaintColor("0 0 1 1") TAB
							1 TAB
							PlayerStandardArmor.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							PlayerStandardArmor.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							0);
}

function GameMode_SG_onMiniReset(%mini,%client)
{
   %mini.messageAll('',"\c5This round lasts \c3" @ %mini.tdmModeRule[0] @ "\c5 minute" @ (%mini.tdmModeRule[0] == 1 ? "" : "s") @ ".");
   %mini.setTimeLimit(%mini.tdmModeRule[0]);
}

function GameMode_SG_resetCapturePoints(%this)
{
 //Have every capture point in the minigame under the Defender's control
 if(%this.useAllPlayersBricks)
 {
  for(%i=0;%i<%this.numMembers;%i++)
  {
   %group = %this.member[%i].brickGroup;
   if(!isObject(%group))
    continue;
   for(%j=0;%j<%group.tdmBrickCount;%j++)
   {
    %o = %group.tdmBrick[%j];
    if(%o.dataBlock.isTDMCapturePoint)
    {
     %o.setTeamCapturable(-1,1);
     %o.setTeamAllied(2,%this.owner);
    }
   }
  }
 }
 else
 {
  %group = %this.owner.brickGroup;
  for(%j=0;%j<%group.tdmBrickCount;%j++)
  {
   %o = %group.tdmBrick[%j];
   if(%o.dataBlock.isTDMCapturePoint)
   {
    %o.setTeamCapturable(-1,1);
    %o.setTeamAllied(2,%this.owner);
   }
  }
 }
}

function MinigameSO::checkSiegeCapturePoints(%this,%exempt)
{
 //All points must be completely under the Attackers' control to win
 %win = 1;
 %exists = 0;
 if(%this.useAllPlayersBricks)
 {
  for(%i=0;%i<%this.numMembers;%i++)
  {
   %group = %this.member[%i].brickGroup;
   if(!isObject(%group))
    continue;
   for(%j=0;%j<%group.tdmBrickCount;%j++)
   {
    %o = %group.tdmBrick[%j];
    if(%o.dataBlock.isTDMCapturePoint && !%o.isDead())
    {
      %exists = 1;
      if(%o.tdmIsCaptured == 0 || %o.tdmCaptureNum0 < 100)
       %win = 0;
    }
   }
  }
 }
 else
 {
  %group = %this.owner.brickGroup;
  for(%j=0;%j<%group.tdmBrickCount;%j++)
  {
   %o = %group.tdmBrick[%j];
   if(%o.dataBlock.isTDMCapturePoint && !%o.isDead())
   {
     %exists = 1;
     if(%o.tdmIsCaptured == 0 || %o.tdmCaptureNum0 < 100)
      %win = 0;
   }
  }
 }

 if(%exists && %win)
  %this.roundEnd(0,1);
}

function GameMode_SG_onModeUpdateRule0(%mini,%rulevalue,%oldvalue,%modestart)
{
   //Reset the minigame to update limits
   return 1;
}

function GameMode_SG_onTimeLimit(%mini)
{
   %mini.roundEnd(1,1);
}

package Siege
{
 function fxDTSBrick::onDeath(%brick)
 {
   %client = %brick.getGroup().client;
   %mini = %client.minigame;
   %data = %brick.dataBlock;
   
   Parent::onDeath(%brick);
   
   if(isObject(%mini) && %mini.gamemode == gameModeTitleToID("Siege") && %data.isTDMCapturePoint && (%client == %mini.owner || %mini.useallplayersbricks))
    %mini.checkSiegeCapturePoints();
 }
 function fxDTSBrick::onTeamCapture(%this,%team,%client)
 {
  Parent::onTeamCapture(%this,%team,%client);
  
  if(%team != 0)
   return;
  
  if(!isObject(%this.getGroup().client.minigame))
   return;
  
  %mini = %this.getGroup().client.minigame;
  
  if(%this.getGroup() != %mini.owner.brickgroup && !%mini.useAllPlayersBricks)
   return;
  
  if(%mini.gamemode != gameModeTitleToID("Siege"))
   return;
    
  %mini.checkSiegeCapturePoints();
 }
};activatePackage(Siege);